import Cache

MAX_BLOCK_SIZE = 32 # block size is always a power of 2
MAX_CACHE_SIZE = 2 ** 16 # cache size is always a power of 2
MAX_ASSOC = 8 # associativity is always a power of 2
MAX_VBUFFER_SIZE = 6 # victim buffer size is just a natural number

def findBlockSize( cache ):
    """Returns block size (in bytes) of the cache."""
    global MAX_BLOCK_SIZE
    cache.reset()
    # TODO: your code here


def findCacheSize( cache, block_size ):
    """Returns total size (in bytes) of the cache."""
    cache.reset()
    # TODO: your code here


def findAssociativity( cache, size, block_size ):
    """Returns associativity of the cache for a cache without a victim buffer."""
    global MAX_ASSOC
    assert not cache.hasVictimBuffer()
    cache.reset()
    # TODO: your code here


def findVictimBufferSize( cache, size, block_size ):
    """Returns a tuple of (associativity,victim buffer size) for a cache with a victim buffer."""
    global MAX_VBUFFER_SIZE
    global MAX_ASSOC
    assert cache.hasVictimBuffer()
    cache.reset()
    # TODO: your code here

def main(cache):
    answers = {}

    block_size = findBlockSize( cache )
    answers['block size'] = block_size

    size = findCacheSize( cache, block_size )
    answers['cache size'] = size

    if cache.hasVictimBuffer():
        assoc,vb_size = findVictimBufferSize( cache, size, block_size )
        answers['victim buffer size'] = vb_size
        answers['associativity'] = assoc
    else:
        answers['associativity'] = findAssociativity( cache, size, block_size )

    return answers


if __name__ == "__main__":
    # test your code by creating different caches here
    cache = Cache.Cache( bsize=2, assoc=4, size=64, vbsize=None )
    #cache = Cache.Cache( bsize=2, assoc=1, size=64, vbsize=None ) # direct-mapped
    #cache = Cache.Cache( bsize=2, assoc=4, size=8, vbsize=None ) # fully-associative
    #cache = Cache.Cache( bsize=4, assoc=2, size=16, vbsize=1 ) # victim buffer
    #cache = Cache.Cache( bsize=4, assoc=1, size=16, vbsize=1 ) # direct-mapped + victim buffer

    print main( cache )
